import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.ResourceBundle;

/**
 * Title:        DialogAbout.java
 * Description:  The about dialog for Mathgame
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2001
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version 1.0
 */

public class DialogAbout extends JDialog {
  private static ResourceBundle res;
  JPanel panel1 = new JPanel();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabelHeader = new JLabel();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabelCr = new JLabel();
  JLabel jLabelAuthor1 = new JLabel();
  JLabel jLabelAuthor2 = new JLabel();
  JLabel jLabelYear = new JLabel();
  JButton jButtonMail = new JButton();
/**
 * Constructor for DialogAbout
 * @param   frame    Frame for the dialog.
 * @param   title    Title of the dialog.
 * @param   modal    Boolean value which indicates if the dialog is shown as modal.
 * @param   language ResourceBundle for the dialog.
 */

  public DialogAbout(Frame frame, String title, boolean modal, ResourceBundle language) {
    super(frame, title, modal);
    res = language;
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    jPanel1.setLayout(xYLayout1);
    jLabelHeader.setFont(new java.awt.Font("Dialog", 1, 18));
    jLabelHeader.setText(res.getString("Matikka"));
    jLabelCr.setText("Copyright");
    jLabelAuthor1.setText("Annemari Auvinen");
    jLabelAuthor2.setToolTipText("");
    jLabelAuthor2.setText("Anu Niemi");
    jLabelYear.setText("2001");
    jButtonMail.setText(res.getString("Send_Mail_to_Authors"));
    jButtonMail.addActionListener(new DialogAbout_jButtonMail_actionAdapter(this));
    this.getContentPane().add(panel1, BorderLayout.CENTER);
    panel1.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jButtonMail, new XYConstraints(7, 188, 203, -1));
    jPanel1.add(jLabelYear, new XYConstraints(85, 143, 109, 30));
    jPanel1.add(jLabelAuthor2, new XYConstraints(73, 112, 114, 29));
    jPanel1.add(jLabelAuthor1, new XYConstraints(62, 82, 131, 29));
    jPanel1.add(jLabelCr, new XYConstraints(76, 60, 123, 22));
    jPanel1.add(jLabelHeader, new XYConstraints(74, 13, -1, -1));
  }

  void jButtonMail_actionPerformed(ActionEvent e) {
    JFrame frame = new JFrame();
    DialogMail mail = new DialogMail(frame,res.getString("Send_Mail"), false, res);
    mail.show();
  }
}

class DialogAbout_jButtonMail_actionAdapter implements java.awt.event.ActionListener {
  DialogAbout adaptee;

  DialogAbout_jButtonMail_actionAdapter(DialogAbout adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonMail_actionPerformed(e);
  }
}
