import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.ResourceBundle;

/**
 * Title:        DialogMail.java
 * Description:  User can send feedback to author. If sending unsucceed a error
 *               message is shown.
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2001
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 */

public class DialogMail extends JDialog {
  private static ResourceBundle res;
  JPanel panel1 = new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabelHeader = new JLabel();
  JLabel jLabelSender = new JLabel();
  JTextField jTextFieldSender = new JTextField();
  JLabel jLabelHost = new JLabel();
  JTextField jTextFieldHost = new JTextField();
  JButton jButtonSend = new JButton();
  JTextArea jTextAreaMsg = new JTextArea();

/**
 * Constructor for DialogMail
 * @param   frame    Frame for the dialog.
 * @param   title    Title of the dialog.
 * @param   modal    Boolean value which indicates if the dialog is shown as modal.
 * @param   language ResourceBundle for the dialog.
 */
  public DialogMail(Frame frame, String title, boolean modal, ResourceBundle language) {
    super(frame, title, modal);
    res = language;
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    panel1.setLayout(xYLayout1);
    jLabelHeader.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabelHeader.setText(res.getString("Send_email"));
    jLabelSender.setText(res.getString("Sender"));
    jButtonSend.setText(res.getString("Send_feedback"));
    jTextAreaMsg.setText(res.getString("Feedback_"));
    jLabelHost.setText(res.getString("SMTP_protocol"));
    jTextFieldSender.setText("");
    jTextFieldHost.setText("");

    jButtonSend.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonSend_actionPerformed(e);
      }
    });
    getContentPane().add(panel1);
    panel1.add(jButtonSend, new XYConstraints(115, 229, 145, 45));
    panel1.add(jTextFieldSender,  new XYConstraints(201, 50, 120, 25));
    panel1.add(jLabelSender,   new XYConstraints(48, 50, 114, 25));
    panel1.add(jLabelHeader, new XYConstraints(98, 9, 223, 32));
    panel1.add(jLabelHost,  new XYConstraints(48, 100, 116, 25));
    panel1.add(jTextFieldHost,    new XYConstraints(201, 100, 120, 25));
    panel1.add(jTextAreaMsg,            new XYConstraints(48, 150, 273, 50));
  }

  void jButtonSend_actionPerformed(ActionEvent e) {
    String errorMsg;
    MailSender sender = new MailSender();
//If sending unsucceed a error message is shown.
    errorMsg = res.getString("Error_occured_while");
    boolean success = sender.sendMail(jTextFieldSender.getText(),jTextFieldHost.getText(),jTextAreaMsg.getText(),errorMsg);
    if(success) this.dispose();
  }
}
