import java.lang.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.*;
/**
 * Title:         GameAreaNumber.java
 * Description:   GameArea class for number game.
 * Copyright:     Annemari Auvinen, Anu Niemi (c) 2001
 * Company:
 * @author        Annemari Auvinen, Anu Niemi
 * @version       1.0
 *
 * @param   oMin    Int value, which indicates the minimun value for random,
 *                  which indicates the mathematical operator.
 * @param   oMax    Int value, which indicates the maximum value for random,
 *                  which indicates the mathematical operator.
 * @param   max     Maximum int value which is used in the task.
 * @param   onlyPos Boolean value, which is true, if answer of the task should
 *                  be positive.
 */

public class GameAreaNumber extends GameArea{
  private int oMin;
  private int oMax;
  private int max;
  private boolean onlyPos;

/**
 * Constructor for the GameAreaNumber.
 * @param   oMin    Int value, which indicates the minimun value for random,
 *                  which indicates the mathematical operator.
 * @param   oMax    Int value, which indicates the maximum value for random,
 *                  which indicates the mathematical operator.
 * @param   max     Maximum int value which is used in the task.
 * @param   onlyPos Boolean value, which is true, if answer of the task should
 *                  be positive.
 */
  public GameAreaNumber(int oMin, int oMax, int max, boolean onlyPos) {
    super();
    this.oMin=oMin;
    this.oMax=oMax;
    this.max=max;
    this.onlyPos=onlyPos;
    this.setBackground(Color.white); //doesn't work
  }

/**
 * Creates a new bar and task.
 */
  public void createNewTask()
  {
    NumberTask task = new NumberTask(oMin,oMax, max, onlyPos);
    task.newTask();
    tasks.add(task);
    Bar bar= new Bar(task.getProblem());
    bars.add(bar);
    this.add(bar, new XYConstraints(0, 0, -1, -1));
    repaint();
  }
/**
 * Sets the value for the onlyPos parameter.
 * @param pos   Boolean value, which is true, if answer of the task should
 *              be positive.
 */
  public void setOnlyPos(boolean pos)
  {
    onlyPos = pos;
  }
/**
 * Sets the values for parameters oMin, oMax and max.
 * @param   oMin    Int value, which indicates the minimun value for random,
 *                  which indicates the mathematical operator.
 * @param   oMax    Int value, which indicates the maximum value for random,
 *                  which indicates the mathematical operator.
 * @param   max     Maximum int value which is used in the task.
 */
  public void setValues(int oMin, int oMax, int max)
  {
    this.oMin = oMin;
    this.oMax = oMax;
    this.max = max;
  }

}