import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.awt.event.KeyEvent;
import com.borland.dx.sql.dataset.*;
import com.borland.datastore.*;
import com.borland.dbswing.*;
import java.sql.*;
import java.util.*;
/**
 * Title:        MathGame.java
 * Description:  Class
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2001
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 *
 * @param   res         ResourceBundle object.
 * @param   speed       Int table of speed values.
 * @param   level       Int table of level parameters, which are taken and used in
 *                      creating task.
 * @param   language    Int value, which is 0 if the selected language is finnish
 *                      and 1 if the language is english.
 * @param   levelNbr    Int value, which is the selected level.
 * @param   speedNbr    Int value, which is the selected speed.
 * @param   nameIsAsked Boolean value, which indicates whether the player's name
 *                      is asked.
 * @param   mover       The mover object which handles the movement of the bar.
 *
 */

public class MathGame extends JFrame {

  private static ResourceBundle res;
  private int[] speed ={2000, 1500, 1000, 750, 400, 200};
  private int[][] level={{0,0,10},{0,1,10},{0,1,100},{2,2,10},{2,3,10},{0,3,10}};
  private int language;
  private int levelNbr=1;
  private int speedNbr=1;
  private boolean nameIsAsked = false;
  private Mover mover;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanelLeft = new JPanel();
  JPanel jPanelUp = new JPanel();
  JPanel jPanelBottom = new JPanel();
  JPanel jPanelControl = new JPanel();
  GameAreaNumber area = new GameAreaNumber(level[0][0],level[0][1],level[0][2], true);
  JButton jButtonNew = new JButton();
  JLabel jLabelPoints = new JLabel();
  JTextField jTextFieldAnswer = new JTextField();
  JMenuBar jMenuBarMatikka = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuItemNew = new JMenuItem();
  JMenu jMenuLevel = new JMenu();
  JMenuItem jMenuItemBest = new JMenuItem();
  JMenuItem jMenuItemExit = new JMenuItem();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItemS1 = new JMenuItem();
  JMenuItem jMenuItemS2 = new JMenuItem();
  JMenuItem jMenuItemS3 = new JMenuItem();
  JMenuItem jMenuItemS4 = new JMenuItem();
  JMenuItem jMenuItemS5 = new JMenuItem();
  JMenu jMenu2 = new JMenu();
  JMenuItem jMenuItemL1 = new JMenuItem();
  JMenuItem jMenuItemL2 = new JMenuItem();
  JMenuItem jMenuItemL3 = new JMenuItem();
  JMenuItem jMenuItemL4 = new JMenuItem();
  JMenuItem jMenuItemL5 = new JMenuItem();
  JCheckBoxMenuItem jCheckboxMenuItemPos = new  JCheckBoxMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuItemS6 = new JMenuItem();
  JMenuItem jMenuItemL6 = new JMenuItem();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JMenuItem jMenuItemAbout = new JMenuItem();

/**
 * Constructor for the Mathgame.
 */
  public MathGame() {
    try {
      jbInit();
      this.setSize(500,500);
      this.show();
      mover = new Mover(speed[0],area, this);
      mover.start();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

/**
 * The main method of the game.
 */
  public static void main(String[] args) {
    MathGame game = new MathGame();
    game.setSize(500,500);
    game.show();
    game.startGame();
  }

  private void jbInit() throws Exception {
    JFrame frame = new JFrame();
    Object[] options ={"Suomi", "English"};
    language = -1;
//Language to use is asked.
    while (language<0){
      language = JOptionPane.showOptionDialog(frame,"Valitse kieli/Select language ", "", JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,null,options,options[0] );
    }
    if (language==1)
     res = ResourceBundle.getBundle("Res_en");
    else
      res =ResourceBundle.getBundle("Res_fi");
    this.getContentPane().setLayout(borderLayout1);
    repaint();
    jPanelLeft.setBackground(new Color(59, 112, 203));
    jPanelLeft.setMinimumSize(new Dimension(10, 100));
    jPanelLeft.setPreferredSize(new Dimension(10, 100));
    jPanelUp.setBackground(new Color(59, 112, 203));
    jPanelControl.setBackground(new Color(59, 112, 203));
    jPanelControl.setMinimumSize(new Dimension(100, 100));
    jPanelControl.setPreferredSize(new Dimension(100, 100));
    jPanelControl.setLayout(gridBagLayout1);
    jPanelBottom.setBackground(new Color(59, 112, 203));
    area.setBackground(Color.white);
    area.setBorder(BorderFactory.createLineBorder(Color.black));
    area.setDebugGraphicsOptions(DebugGraphics.NONE_OPTION);
    area.setPreferredSize(new Dimension(200, 200));

    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    jButtonNew.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonNew_actionPerformed(e);
      }
    });
    jLabelPoints.setFont(new java.awt.Font(res.getString("Dialog"), 1, 16));
    jLabelPoints.setForeground(Color.black);
    jLabelPoints.setVerifyInputWhenFocusTarget(false);
    jLabelPoints.setText(res.getString("0"));
    jTextFieldAnswer.setText(res.getString("BLANK"));
    this.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        this_keyPressed(e);
      }
    });
    this.setJMenuBar(jMenuBarMatikka);
    jMenuFile.setText(res.getString("File"));
    jMenuItemNew.setText(res.getString("New_Game"));
    jMenuLevel.setText(res.getString("Level"));
    jMenuItemBest.setText(res.getString("Best_Results"));
    jMenuItemExit.setText(res.getString("Exit"));
    jMenu1.setText(res.getString("Speed"));
    jMenu2.setText(res.getString("Difficulty"));
    jMenuHelp.setText(res.getString("Help"));
    jCheckboxMenuItemPos.setText(res.getString("Positive_Results"));
    jButtonNew.setText(res.getString("New_Game"));

    jCheckboxMenuItemPos.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
         jCheckboxMenuItemPos_actionPerformed(e);
      }
    });

    jMenuItemS1.setText(res.getString("1"));
    jMenuItemS1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemS1_actionPerformed(e);
      }
    });

    jMenuItemS2.setText(res.getString("2"));
    jMenuItemS2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemS2_actionPerformed(e);
      }
    });
    jMenuItemS3.setText(res.getString("3"));
    jMenuItemS3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemS3_actionPerformed(e);
      }
    });
    jMenuItemS4.setText(res.getString("4"));
    jMenuItemS4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemS4_actionPerformed(e);
      }
    });
    jMenuItemS5.setText(res.getString("5"));
    jMenuItemS5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemS5_actionPerformed(e);
      }
    });
   jMenuItemS6.setText(res.getString("6"));
    jMenuItemS6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemS6_actionPerformed(e);
      }
    });
    jMenuItemL1.setText(res.getString("1"));
    jMenuItemL1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemL1_actionPerformed(e);
      }
    });
    jMenuItemL2.setText(res.getString("2"));
    jMenuItemL2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemL2_actionPerformed(e);
      }
    });
    jMenuItemL3.setText(res.getString("3"));
    jMenuItemL3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemL3_actionPerformed(e);
      }
    });
    jMenuItemL4.setText(res.getString("4"));
    jMenuItemL4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemL4_actionPerformed(e);
      }
    });
    jMenuItemL5.setText(res.getString("5"));
    jMenuItemL5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemL5_actionPerformed(e);
      }
    });

    jMenuItemNew.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemNew_actionPerformed(e);
      }
    });
    jMenuItemExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemExit_actionPerformed(e);
      }
    });

    jMenuItemL6.setText(res.getString("6"));
    jMenuItemL6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemL6_actionPerformed(e);
      }
    });
    jMenuItemBest.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemBest_actionPerformed(e);
      }
    });

    jMenuItemAbout.setText(res.getString("About"));
    jMenuItemAbout.addActionListener(new MathGame_jMenuItemAbout_actionAdapter(this));
    this.getContentPane().add(jPanelLeft, BorderLayout.WEST);
    this.getContentPane().add(jPanelUp, BorderLayout.NORTH);
    this.getContentPane().add(jPanelBottom, BorderLayout.SOUTH);
    this.getContentPane().add(jPanelControl,  BorderLayout.EAST);
    jPanelControl.add(jTextFieldAnswer,      new GridBagConstraints(0, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 19), 0, 0));
    jPanelControl.add(jLabelPoints, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelControl.add(jButtonNew, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4, -2, 1, 20), 0, 0));
    this.getContentPane().add(area, BorderLayout.CENTER);
    jMenuBarMatikka.add(jMenuFile);
    jMenuBarMatikka.add(jMenuLevel);
    jMenuBarMatikka.add(jMenuHelp);
    jMenuFile.add(jMenuItemNew);
    jMenuFile.add(jMenuItemBest);
    jMenuFile.add(jMenuItemExit);
    jMenuLevel.add(jMenu1);
    jMenuLevel.add(jMenu2);
    jMenu1.add(jMenuItemS1);
    jMenu1.add(jMenuItemS2);
    jMenu1.add(jMenuItemS3);
    jMenu1.add(jMenuItemS4);
    jMenu1.add(jMenuItemS5);
    jMenu1.add(jMenuItemS6);
    jMenu2.add(jMenuItemL1);
    jMenu2.add(jMenuItemL2);
    jMenu2.add(jMenuItemL3);
    jMenu2.add(jMenuItemL4);
    jMenu2.add(jMenuItemL5);
    jMenu2.add(jMenuItemL6);
    jMenuLevel.add(jCheckboxMenuItemPos);
    jMenuHelp.add(jMenuItemAbout);
    jCheckboxMenuItemPos.setState(true);
    jTextFieldAnswer.setText(res.getString("BLANK"));
    jTextFieldAnswer.selectAll();
  }

  void this_windowClosing(WindowEvent e) {
     System.exit(0);
  }

  void this_keyPressed(KeyEvent e) {
    int pos=0;
    //Reacts to enter. Checks whether the given answer is right or not.
    //If the answer is right, the points is increased by a number depending on
    //the selected speed and level and the moving bar is destroyed and new one
    //is created.
    if (e.getKeyCode() == KeyEvent.VK_ENTER)
    {
       if (area.isAnswerRight(jTextFieldAnswer.getText()))
       {
         if (jCheckboxMenuItemPos.getState())
           pos =1;
         int points = Integer.parseInt(jLabelPoints.getText()) + speedNbr + levelNbr + pos;
         jLabelPoints.setText(Integer.toString(points));
         area.deleteBar();
         area.createNewTask();
      }
      jTextFieldAnswer.setText(res.getString("BLANK"));
    }
  }
/**
 * Starts the game.
 */
  public void startGame()
  {
    area.newGame();
  }
/**
 * Stops the current game and creates a new one.
 */
  public void newGame(){
    mover.interrupt();
    nameIsAsked = false;
    area.newGame();
    mover = new Mover(speed[speedNbr-1],area, this);
    mover.start();
  }
/**
 * Asks player's name and adds the name and points into the database and sets
 * points as zero.
 */
  public synchronized void endGame() {
    if (!nameIsAsked)
    {
      Database databaseBest2 = new Database();
      QueryDataSet queryDataSet2 = new QueryDataSet();
      databaseBest2.setConnection(new com.borland.dx.sql.dataset.ConnectionDescriptor(res.getString("jdbc_odbc_Parhaat"), res.getString("BLANK"), res.getString("BLANK"), false, res.getString("sun_jdbc_odbc")));
      Connection con = databaseBest2.jdbcConnection();
      JFrame frame= new JFrame();

      String name =null;
      while(name==null)
      {
        name = JOptionPane.showInputDialog(frame,res.getString("Type_your_name"), res.getString("BLANK"),1);
      }
      nameIsAsked=true;
      Statement stmt;
      try {
        stmt=con.createStatement();
        String number = "SELECT * FROM HighScore";
        ResultSet rs = stmt.executeQuery(number);
        int id = 1;
        while(rs.next()) {
          id++;
        }
        String sql = "INSERT INTO HighScore(Id,Name, Points ) VALUES("+id+", '"+name+"',"+jLabelPoints.getText()+")";
        stmt.executeUpdate(sql);
        stmt.close();
        con.close();
      } catch (SQLException sqle) {
      }
    }
    jLabelPoints.setText(res.getString("0"));
  }

  void jMenuItemNew_actionPerformed(ActionEvent e) {
    newGame();
  }

  void jMenuItemExit_actionPerformed(ActionEvent e) {
   System.exit(0);
  }

  void jMenuItemS1_actionPerformed(ActionEvent e) {
    mover.setSpeed(speed[0]);
    speedNbr = 1;
  }
  void jMenuItemS2_actionPerformed(ActionEvent e) {
    mover.setSpeed(speed[1]);
    speedNbr = 2;
  }

  void jMenuItemS3_actionPerformed(ActionEvent e) {
    mover.setSpeed(speed[2]);
    speedNbr = 3;
  }
   void jMenuItemS4_actionPerformed(ActionEvent e) {
    mover.setSpeed(speed[3]);
    speedNbr = 4;
  }

  void jMenuItemS5_actionPerformed(ActionEvent e) {
    mover.setSpeed(speed[4]);
    speedNbr = 5;
  }

 void jMenuItemS6_actionPerformed(ActionEvent e) {
    mover.setSpeed(speed[5]);
    speedNbr = 6;
  }

  void jMenuItemL1_actionPerformed(ActionEvent e) {
   area.setValues(level[0][0],level[0][1], level[0][2]);
   levelNbr = 1;
  }

  void jMenuItemL2_actionPerformed(ActionEvent e) {
    area.setValues(level[1][0],level[1][1], level[1][2]);
    levelNbr = 2;
  }

  void jMenuItemL3_actionPerformed(ActionEvent e) {
    area.setValues(level[2][0],level[2][1], level[2][2]);
    levelNbr = 3;
  }

  void jMenuItemL4_actionPerformed(ActionEvent e) {
    area.setValues(level[3][0],level[3][1], level[3][2]);
    levelNbr = 4;
  }

  void jMenuItemL5_actionPerformed(ActionEvent e) {
    area.setValues(level[4][0],level[4][1], level[4][2]);
    levelNbr = 5;
  }

  void jMenuItemL6_actionPerformed(ActionEvent e) {
    area.setValues(level[5][0],level[5][1], level[5][2]);
    levelNbr = 6;
  }

  void jCheckboxMenuItemPos_actionPerformed(ActionEvent e) {
    area.setOnlyPos( jCheckboxMenuItemPos.getState());
  }

  void jButtonNew_actionPerformed(ActionEvent e) {
    newGame();
  }

  void jMenuItemBest_actionPerformed(ActionEvent e) {
     JFrame frame = new JFrame();
     DialogBest bests = new DialogBest(frame,res.getString("Best_Results"), false);
     bests.show();
  }

  void jMenuItemAbout_actionPerformed(ActionEvent e) {
    JFrame frame = new JFrame();
    DialogAbout about = new DialogAbout(frame,res.getString("About"), false, res);

    about.show();
  }

class MathGame_jMenuItemAbout_actionAdapter implements java.awt.event.ActionListener {
  MathGame adaptee;

  MathGame_jMenuItemAbout_actionAdapter(MathGame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItemAbout_actionPerformed(e);
  }
}


}