import java.awt.*;

/**
 * Title:        Task.java
 * Description:  Abstract Task class.
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2001
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 *
 * @param   answer    String value, which is the answer of the task.
 * @param   problem   String value, which is the task.
 */

abstract class Task {
  private String answer;
  private String problem;

/**
 * Constructor for the Task.
 */
  public Task() {
  }
 /**
  * Sets the answer.
  * @param    answer    String value, which is the answer to set.
  */
  public void setAnswer(String answer) {
    this.answer = answer;
  }
/**
  * Sets the problem.
  * @param    problem    String value, which is the problem to set.
  */
  public void setProblem(String problem) {
    this.problem = problem;
  }

/**
 * Abstract method for creating a new task.
 */
  protected abstract void newTask();

/**
 * Returns the problem.
 * @return      String value, which is the task.
 */
  public String getProblem()
  {
    return problem;
  }
/**
 * Checks whether the parameter answer is the right answer to the given task.
 * @param   answer   String to check.
 * @return           Boolean which indicates whether the answer was right or not.
 */
  public boolean isAnswerRight(String answer) {
    if (answer.equals(this.answer))
      return true;
    return false;
  }
}